Index: branches/HTM-14.1-update-dev0/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1200)
@@ -946,41 +975,39 @@
           m_cTVideoIOYuvReconFile.write( pcPic->getPicYuvRec(),
 #endif
-                                        conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
-                                        conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
-                                        conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
-                                        conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset() );
-        }
-        
+                                         m_outputColourSpaceConvert,
+                                         conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
+                                         conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
+                                         conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
+                                         conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(), 
+#if NH_3D
+                                         m_depth420OutputFlag && pcPic->getIsDepth() ? CHROMA_420 : NUM_CHROMA_FORMAT
+#else
+                                         NUM_CHROMA_FORMAT
+#endif
+                                         , m_bClipOutputVideoToRec709Range);
+        }
+
         // update POC of display order
-#if H_MV
+#if NH_MV
       m_pocLastDisplay[decIdx] = pcPic->getPOC();
 #else
         m_iPOCLastDisplay = pcPic->getPOC();
 #endif
-        
+
         // erase non-referenced picture in the reference picture list after display
         if ( !pcPic->getSlice(0)->isReferenced() && pcPic->getReconMark() == true )
         {
-#if !DYN_REF_FREE
           pcPic->setReconMark(false);
-          
+
           // mark it should be extended later
           pcPic->getPicYuvRec()->setBorderExtension( false );
-          
-#else
-          pcPic->destroy();
-          pcListPic->erase( iterPic );
-          iterPic = pcListPic->begin(); // to the beginning, non-efficient way, have to be revised!
-          continue;
-#endif
         }
         pcPic->setOutputMark(false);
-#if H_MV
+#if NH_MV
         pcPic->setPicOutputFlag(false);
 #endif
       }
-#if !H_MV
-#if !DYN_REF_FREE
-      if(pcPic)
+#if !NH_MV
+      if(pcPic != NULL)
       {
         pcPic->destroy();
@@ -988,10 +1015,9 @@
         pcPic = NULL;
       }
-#endif    
 #endif
       iterPic++;
     }
   }
-#if H_MV
+#if NH_MV
   m_pocLastDisplay[decIdx] = -MAX_INT;
 #else
@@ -1011,8 +1037,8 @@
   for (std::vector<Int>::iterator it = m_targetDecLayerIdSet.begin(); it != m_targetDecLayerIdSet.end(); it++)
   {
-#if H_MV
-    if ( nalu->m_layerId == (*it) )
-#else
-    if ( nalu->m_reservedZero6Bits == (*it) )
+#if NH_MV
+    if ( nalu->m_nuhLayerId == (*it) )
+#else
+    if ( nalu->m_nuhLayerId == (*it) )
 #endif
     {
@@ -1023,5 +1049,5 @@
 }
 
-#if H_MV
+#if NH_MV
 Int TAppDecTop::xGetDecoderIdx( Int layerId, Bool createFlag /*= false */ )
 {
@@ -1052,10 +1078,14 @@
     m_tDecTop[ decIdx ]->setIvPicLists( &m_ivPicLists ); 
     m_tDecTop[ decIdx ]->setLayerInitilizedFlags( m_layerInitilizedFlags );
-    m_tDecTop[ decIdx ]->setTargetOptLayerSetIdx( m_targetOptLayerSetIdx );    
-#if H_3D
-    m_tDecTop[ decIdx ]->setProfileIdc           ( );    
-#endif
-
-#if H_3D
+    m_tDecTop[ decIdx ]->setTargetOlsIdx( m_targetOptLayerSetIdx );    
+#if O0043_BEST_EFFORT_DECODING
+    m_cTDecTop[ decIdx ]->setForceDecodeBitDepth(m_forceDecodeBitDepth);
+#endif
+    if (!m_outputDecodedSEIMessagesFilename.empty())
+    {
+      std::ostream &os=m_seiMessageFileStream.is_open() ? m_seiMessageFileStream : std::cout;
+      m_tDecTop[ decIdx ]->setDecodedSEIMessageOutputStream(&os);
+    }
+#if NH_3D
    m_tDecTop[ decIdx ]->setCamParsCollector( &m_cCamParsCollector );
 #endif
Index: branches/HTM-14.1-update-dev0/source/App/TAppDecoder/TAppDecTop.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/App/TAppDecoder/TAppDecTop.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/App/TAppDecoder/TAppDecTop.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -61,5 +61,5 @@
 private:
   // class interface
-#if H_MV
+#if NH_MV
   TDecTop*                        m_tDecTop             [ MAX_NUM_LAYERS ];    ///< decoder classes
   TVideoIOYuv*                    m_tVideoIOYuvReconFile[ MAX_NUM_LAYERS ];    ///< reconstruction YUV class
@@ -68,11 +68,11 @@
   TComPicLists                    m_ivPicLists;                                ///< picture buffers of decoder instances
   Bool                            m_layerInitilizedFlags[ MAX_NUM_LAYER_IDS ]; ///< for layerwise startup 
-  TComVPS*                        m_vps;                                ///< active VPS
+  const TComVPS*                  m_vps;                                ///< active VPS
 #else
   TDecTop                         m_cTDecTop;                     ///< decoder class
   TVideoIOYuv                     m_cTVideoIOYuvReconFile;        ///< reconstruction YUV class
 #endif
-    // for output control
-#if H_MV
+  // for output control
+#if NH_MV
   Int                             m_pocLastDisplay      [ MAX_NUM_LAYERS ]; ///< last POC in display order
   Bool                            m_reconOpen           [ MAX_NUM_LAYERS ]; ///< reconstruction file opened
@@ -81,6 +81,7 @@
   Int                             m_iPOCLastDisplay;              ///< last POC in display order
 #endif
+  std::ofstream                   m_seiMessageFileStream;         ///< Used for outputing SEI messages.
 
-#if H_3D
+#if NH_3D
   FILE*                           m_pScaleOffsetFile;
   CamParsCollector                m_cCamParsCollector;
@@ -89,8 +90,24 @@
   TAppDecTop();
   virtual ~TAppDecTop() {}
-  
+
   Void  create            (); ///< create internal members
   Void  destroy           (); ///< destroy internal members
   Void  decode            (); ///< main decoding function
+#if NH_MV
+  UInt  getNumberOfChecksumErrorsDetected( ) const 
+  {
+    UInt numOfChecksumErrors = 0; 
+    for (Int i = 0; i < m_numDecoders; i++ )
+    {
+      numOfChecksumErrors += getNumberOfChecksumErrorsDetected( i ); 
+    }
+    return numOfChecksumErrors; 
+  }
+
+  UInt  getNumberOfChecksumErrorsDetected( Int decIdx ) const { return m_tDecTop[decIdx]->getNumberOfChecksumErrorsDetected(); }
+
+#else
+  UInt  getNumberOfChecksumErrorsDetected() const { return m_cTDecTop.getNumberOfChecksumErrorsDetected(); }
+#endif
 
 protected:
@@ -99,5 +116,5 @@
   Void  xInitDecLib       (); ///< initialize decoder class
 
-#if H_MV
+#if NH_MV
   Void  xWriteOutput      ( TComList<TComPic*>* pcListPic, Int layerId, Int tId ); ///< write YUV to file
 
Index: branches/HTM-14.1-update-dev0/source/App/TAppDecoder/decmain.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/App/TAppDecoder/decmain.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/App/TAppDecoder/decmain.cpp	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -44,6 +44,4 @@
 //! \{
 
-bool g_md5_mismatch = false; ///< top level flag that indicates if there has been a decoding mismatch
-
 // ====================================================================================================================
 // Main function
@@ -52,12 +50,13 @@
 int main(int argc, char* argv[])
 {
+  Int returnCode = EXIT_SUCCESS;
   TAppDecTop  cTAppDecTop;
 
   // print information
   fprintf( stdout, "\n" );
-#if H_MV
+#if NH_MV
   fprintf( stdout, "3D-HTM Software: Decoder Version [%s] based on HM Version [%s]", NV_VERSION, HM_VERSION );  
 #else
-  fprintf( stdout, "HM software: Decoder Version [%s]", NV_VERSION );
+  fprintf( stdout, "HM software: Decoder Version [%s] (including RExt)", NV_VERSION );
 #endif
   fprintf( stdout, NVM_ONOS );
@@ -73,21 +72,23 @@
   {
     cTAppDecTop.destroy();
-    return 1;
+    returnCode = EXIT_FAILURE;
+    return returnCode;
   }
 
   // starting time
-  double dResult;
-  long lBefore = clock();
+  Double dResult;
+  clock_t lBefore = clock();
 
   // call decoding function
   cTAppDecTop.decode();
 
-  if (g_md5_mismatch)
+  if (cTAppDecTop.getNumberOfChecksumErrorsDetected() != 0)
   {
     printf("\n\n***ERROR*** A decoding mismatch occured: signalled md5sum does not match\n");
+    returnCode = EXIT_FAILURE;
   }
 
   // ending time
-  dResult = (double)(clock()-lBefore) / CLOCKS_PER_SEC;
+  dResult = (Double)(clock()-lBefore) / CLOCKS_PER_SEC;
   printf("\n Total Time: %12.3f sec.\n", dResult);
 
@@ -95,5 +96,5 @@
   cTAppDecTop.destroy();
 
-  return g_md5_mismatch ? EXIT_FAILURE : EXIT_SUCCESS;
+  return returnCode;
 }
 
